#!/usr/bin/perl -w

# USE
use English;
use Getopt::Long;
use POSIX;

# DEFINES
my $start;
my $stop;
my $stopa;
my $stopb;
my $stopc;
my $stopd;
my $help;

$aanvalAppsDir = `cd \`dirname $0\`;pwd`;
chop($aanvalAppsDir);

$vMajor = 1;
$vMinor = 2;
$vBuild = 107;

# OPTIONS
GetOptions (
		'start' => \$start,
		'stop' => \$stop,
		'stopa' => \$stopa,
		'stopb' => \$stopb,
		'stopc' => \$stopc,
		'stopd' => \$stopd,
		'help' => \$help
		);
		
# Ready set go!
launch();		
		
sub launch {

	my $run = 1;

	print "---\nAanval Background Processing Unit (BPU) Initializer\nVersion: $vMajor.$vMinor.$vBuild\n---\n";

	# PERL TEST
	$command = "perl";
	for $dir (split /:/, $ENV{PATH}) { 
	   last if ($existsP = (-x "$dir/$command")); 
	} 
	die "Fatal Error -> '$command' command not found. Ensure this command is in your path before continuing.\n" unless ($existsP); 	
	
	# PHP TEST
	$command = "php";
	for $dir (split /:/, $ENV{PATH}) { 
	   last if ($existsP = (-x "$dir/$command")); 
	} 
	die "Fatal Error -> '$command' command not found. Ensure this command is in your path before continuing.\n" unless ($existsP); 		
	
	# Stopping
	if ($stop) {
		$stopa = 1;
		$stopb = 1;
		$stopc = 1;
		$stopd = 1;
	}
	
	if ($stopa) {
		print "Stopping BPU A\n";
		if (-e "$aanvalAppsDir/pidA") { 
			system("kill -9 `cat $aanvalAppsDir/pidA` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidA");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	} 
	if ($stopb) {
		print "Stopping BPU B\n";
		if (-e "$aanvalAppsDir/pidB") { 
			system("kill -9 `cat $aanvalAppsDir/pidB` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidB");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	}
	if ($stopc) {
		print "Stopping BPU C\n";
		if (-e "$aanvalAppsDir/pidC") { 
			system("kill -9 `cat $aanvalAppsDir/pidC` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidC");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	}
	if ($stopd) {
		print "Stopping BPU D\n";
		if (-e "$aanvalAppsDir/pidD") { 
			system("kill -9 `cat $aanvalAppsDir/pidD` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidD");
			print "Stopped\n";
		} else {
			print "Nothing to stop\n";
		}
	}	
	
	if ($stop || $stopa || $stopb || $stopc || $stopd) { exit; }
	
	# Exit immediately if this launch isn't going anywhere
	if (!$start && !$help) { print "\nNothing to do. Try -help\n\n"; $run = 0; }
	
	# Display Help
	if ($help) { displayHelp(); $run = 0; }

	if ($run == 1) {
		
		if (-e "$aanvalAppsDir/pidA") { 
			system("kill -9 `cat $aanvalAppsDir/pidA` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidA");
		}
        system("perl $aanvalAppsDir/processorA.pl -start");
        
		if (-e "$aanvalAppsDir/pidB") { 
			system("kill -9 `cat $aanvalAppsDir/pidB` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidB");
		}
        system("perl $aanvalAppsDir/processorB.pl -start");

		if (-e "$aanvalAppsDir/pidC") { 
			system("kill -9 `cat $aanvalAppsDir/pidC` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidC");
		}
        system("perl $aanvalAppsDir/processorC.pl -start");

		if (-e "$aanvalAppsDir/pidD") { 
			system("kill -9 `cat $aanvalAppsDir/pidD` 2>/dev/null");
			system("rm -f $aanvalAppsDir/pidD");
		}
        system("perl $aanvalAppsDir/processorD.pl -start");
	}

	exit;
}

sub displayHelp {

	print "Usage: perl idsBackground.pl [options]\n\n";
	
	print "-start       Start all Aanval Background Processors\n";
	print "-stop        Stop all Aanval Background Processors\n";
	print "-stopa       Stop only BPU A (IMPORTER)\n";
	print "-stopb       Stop only BPU B (CORE)\n";
	print "-stopc       Stop only BPU C (INDEXER)\n";
	print "-stopd       Stop only BPU D (ALERT)\n";
	print "-help        This Help Information\n";
	print "\n";
	print "Example: perl idsBackground.pl -start\n";
	print "\n";

}
