<?php

// Sets
error_reporting(E_ALL ^ E_NOTICE);
ini_set("memory_limit", -1);
ini_set("display_errors", 1);

// Tell the system we are in processor mode
$processor = 1;

// Set some initital variables
$processorVersion = "4.7";

// Includes
if (!@include "../conf/conf.php") {
	echo "Console BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Console BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "The console is in setup / upgrade mode - Exiting.\n\n";
	exit;
}

// php module checking
$module = "mysql";
if (checkModule("$module") == 0) {
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
	procWrite("C", "----------------------------------------------------\n");
	procWrite("C", ".! Fatal Error: $module module not available.\n");
	procwrite("C", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("C", "You must recompile your php binary (cgi) with $module support.");
	procwrite("C", "This must be corrected before console will operate correctly.\n");
	exit;
}
$module = "pcre";
if (checkModule("$module") == 0) {
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: BPU: Background Processing Unit C v$processorVersion");
	procWrite("C", "----------------------------------------------------\n");
	procWrite("C", ".! Fatal Error: $module module not available.\n");
	procwrite("C", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("C", "You must recompile your php binary (cgi) with $module support.");
	procwrite("C", "This must be corrected before console will operate correctly.\n");
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Load Database Connections
$idsDB = new idsDB;

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

function cLoop() {
	global $root_path, $processorVersion, $flashWriteCount, $masterCnt;

	// Away we go!
	$timerStart = date("U");
	
	procWrite("C", "RESET");
	
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: Background Processing Unit C v$processorVersion");
	procWrite("C", ":: " . versionText());
	procWrite("C", ":: Date & Time " . timeDisplay($timerStart, 1));
	procWrite("C", ":: Finished " . statusProcessorLastRunDiff("C") . " seconds ago");
	procWrite("C", "----------------------------------------------------");
	
	// Hold Check
	if (file_exists("$root_path/tmp/holdC.tmp")) { procwrite("C", ":: Processor On Hold -> Exiting"); exit;	}
	
	// Customized Operations Loading
	customOperations();	
	
	// Index System
	indexer();
	
	// Index Deletion
	deleteIndexProcessor();
	
	$objStatus = new myStatus();
	$objStatus->loadStatus();
	$objStatus->setStatusVar("processorC_lastRun", date("U"));
	$objStatus->totalProcessorRunIncrement("C");
	
	$timerDiff = date("U") - $timerStart;
	
	// Footer
	procWrite("C", "----------------------------------------------------");
	procWrite("C", ":: Iteration $masterCnt");
	procWrite("C", ":: Completed in $timerDiff seconds");
	procWrite("C", "----------------------------------------------------");

}

while ($masterCnt != ops("site_bpuIterationC")) {
	$masterCnt++;

	// Perform Loop
	cLoop();
	
	// Sleep
	sleep(ops("site_bpuSleepC"));
}

// Close Database Connections
$idsDB->close();

exit;

?>