<?php

// Sets
error_reporting(E_ALL ^ E_NOTICE);
ini_set("memory_limit", -1);
ini_set("display_errors", 1);

// Tell the system we are in processor mode
$processor = 1;

// Set some initital variables
$processorVersion = "5.4";

// Includes
if (!@include "../conf/conf.php") {
	echo "Console BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ../conf/conf.php - Missing or not found.\n\n";
	exit;
}
if (!@include "./processor.php") {
	echo "Console BPU Fatal Error: This console is not properly configured. Please re-install.\n\n";
	echo "FILE: ./processor.php - Missing or not found.\n\n";
	exit;
}

// Exit if in setup or upgrade mode
if (file_exists("../installation/setup.php")) {
	echo "The console is in setup / upgrade mode - Exiting.\n\n";
	exit;
}

// php module checking
$module = "mysql";
if (checkModule("$module") == 0) {
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: BPU: Background Processing Unit D v$processorVersion");
	procWrite("D", "----------------------------------------------------\n");
	procWrite("D", ".! Fatal Error: $module module not available.\n");
	procwrite("D", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("D", "You must recompile your php binary (cgi) with $module support.");
	procwrite("D", "This must be corrected before console will operate correctly.\n");
	exit;
}
$module = "pcre";
if (checkModule("$module") == 0) {
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: BPU: Background Processing Unit D v$processorVersion");
	procWrite("D", "----------------------------------------------------\n");
	procWrite("D", ".! Fatal Error: $module module not available.\n");
	procwrite("D", "The required module [$module] is not available within your php binary (cgi).");
	procwrite("D", "You must recompile your php binary (cgi) with $module support.");
	procwrite("D", "This must be corrected before console will operate correctly.\n");
	exit;
}

// Load appropriate modules
recursiveModuleLoad(0);

// Load Database Connections
$idsDB = new idsDB;

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();
	
function dLoop() {
	global $root_path, $processorVersion, $flashWriteCount, $masterCnt;

	// Away we go!
	$timerStart = date("U");
	
	procWrite("D", "RESET");
	
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: Background Processing Unit D v$processorVersion");
	procWrite("D", ":: " . versionText());
	procWrite("D", ":: Date & Time " . timeDisplay($timerStart, 1));
	procWrite("D", ":: Finished " . statusProcessorLastRunDiff("D") . " seconds ago");
	procWrite("D", "----------------------------------------------------");
	
	// Hold Check
	if (file_exists("$root_path/tmp/holdD.tmp")) { procwrite("D", ":: Processor On Hold -> Exiting"); exit;	}
	
	// Customized Operations Loading
	customOperations();	

	// AI (Artificial Intelligence)
	analysisProcessor();
	
	// Mail Processor
	processMail();
	
	$objStatus = new myStatus();
	$objStatus->loadStatus();
	$objStatus->setStatusVar("processorD_lastRun", date("U"));
	$objStatus->totalProcessorRunIncrement("D");
	
	$timerDiff = date("U") - $timerStart;
	
	// Footer
	procWrite("D", "----------------------------------------------------");
	procWrite("D", ":: Iteration $masterCnt");
	procWrite("D", ":: Completed in $timerDiff seconds");
	procWrite("D", "----------------------------------------------------");

}

while ($masterCnt != ops("site_bpuIterationD")) {
	$masterCnt++;

	// Perform Loop
	dLoop();
	
	// Sleep
	sleep(ops("site_bpuSleepD"));
}

// Close Database Connections
$idsDB->close();

exit;

?>
