<?php

error_reporting(E_ALL ^ E_NOTICE);

ini_set("session.bug_compat_42", 1);
ini_set("session.bug_compat_warn", 0);
ini_set("memory_limit", -1);
ini_set("display_errors", 1);
ini_set("display_startup_errors", 1);

if (!@include("./conf.php")) { echo "\nERROR: Local \"conf.php\" not present. Exiting.\n"; exit; }
if (!@include("../../../conf/conf.php")) { echo "\nERROR: Console \"conf.php\" not present. Exiting.\n"; exit; }

$ver = "1.0";

recursiveModuleLoad();

$idsDB = new idsDB;

$ops = new myOps();
$ops->loadOps();

$migrateDB = new migrateDB();

migrateProcessor();

function migrateProcessor() {
	global $ver;
	
	echo "\nConsole Data Migration Utility v$ver\n";
	echo "Specifically designed to migrate 2.x (idsMain) data to 3.x (dataStore) data\n---\n\n";
	echo "WARNING: All Background processors must be stopped (very stopped)!\n\n";
	
	echo "Select Migration Type:\n\t1 = idsMain (Main Events)\n\t2 = idsArchives\n\tq = Quit\n\n[1 / 2 / q]?";
	$input = getInput();

	if (!$input) $input = "q";
	
	if (strtolower($input) == "q") exit;
	
	migrateMain($input);
	
}

function migrateMain($type) {
	global $migrateDB, $ver;

	$dataStoreObj = new dataStore();
	
	if ($type == 1) {
		$queryResultA = $migrateDB->query("show tables like 'idsMain'");
	} else if ($type == 2) {
		$queryResultA = $migrateDB->query("show tables like '%_%'");
	}
	for ($i = 0; $rowA = mysql_fetch_row($queryResultA); $i++) {
	
		if ($type == 2) {
			if (!strstr($rowA[0], "_")) continue;
		}
		
		$queryResultB = $migrateDB->query("select count(*) from $rowA[0]");
    	for ($p = 0; $rowB = mysql_fetch_row($queryResultB); $p++) {

    		$name = "$rowA[0]";
    		
			if ($type == 2) {
				$queryResultT = $migrateDB->query("select name from idsArchive where tablename = '$rowA[0]'");
		    	for ($t = 0; $rowT = mysql_fetch_row($queryResultT); $t++) {
		    		$name = "$rowT[0] '$rowA[0]'";
		    	}
			}
    		
			echo "\nConfirm Migrate Selection ($type):\n\tTable: $name\n\tTotal Events: $rowB[0]\n\n[y / n / q]?";
			$input = getInput();
			
			if (strtolower($input) == "q") exit;
			
			if (strtolower($input) == "y" || strtolower($input) == "yes") {
				echo "Processing [$rowA[0]] ...\n";
				
				$queryResultC = $migrateDB->query("select 
					id,
					module,
					sip,
					dip,
					sport,
					dport,
					proto,
					payload,
					level,
					ename,
					etypename,
					epoch,
					timestamp,
					etypeid,
					enameid,
					sid,
					sensorid,
					xcol1,
					xcol2,
					xcol3,
					xcol4,
					xcol5,
					misc1,
					misc2,
					misc3,
					misc4,
					misc5,
					egid,
					enabled,
					hdr_seq,
					hdr_ack,
					hdr_off,
					hdr_res,
					hdr_flags,
					hdr_win,
					hdr_csum,
					hdr_urp,
					hdr_len,
					hdr_id,
					hdr_code,
					hdr_type,
					ip_ver,
					ip_hlen,
					ip_tos,
					ip_len,
					ip_id,
					ip_off,
					ip_flags,
					ip_ttl,
					ip_csum
					from $rowA[0] order by id");
		    	for ($e = 0; $rowC = mysql_fetch_row($queryResultC); $e++) {
				
					$dataStoreObj->writeDiskEventData(array(
					"datastore" => "1.1",
					"migration" => "$ver",
					"module" => "$rowC[1]",
					"src" => "$rowC[2]",
					"dst" => "$rowC[3]",
					"sport" => "$rowC[4]",
					"dport" => "$rowC[5]",
					"ip_proto" => "$rowC[6]",
					"data_payload" => "$rowC[7]",
					"sig_priority" => "$rowC[8]",
					"sig_name" => "$rowC[9]",
					"sig_class_name" => "$rowC[10]",
					"intime" => "$rowC[11]",
					"timestamp" => "$rowC[12]",
					"sig_class" => "$rowC[13]",
					"sig_sid" => "$rowC[14]",
					"sid" => "$rowC[15]",
					"sensorid" => "$rowC[16]",
					"xcol1" => "$rowC[17]",
					"xcol2" => "$rowC[18]",
					"xcol3" => "$rowC[19]",
					"xcol4" => "$rowC[20]",
					"xcol5" => "$rowC[21]",
					"misc1" => "$rowC[22]",
					"misc2" => "$rowC[23]",
					"misc3" => "$rowC[24]",
					"misc4" => "$rowC[25]",
					"misc5" => "$rowC[26]",
					"sig_gid" => "$rowC[27]",
					"enabled" => "$rowC[28]",
					"hdr_seq" => "$rowC[29]",
					"hdr_ack" => "$rowC[30]",
					"hdr_off" => "$rowC[31]",
					"hdr_res" => "$rowC[32]",
					"hdr_flags" => "$rowC[33]",
					"hdr_win" => "$rowC[34]",
					"hdr_csum" => "$rowC[35]",
					"hdr_urp" => "$rowC[36]",
					"hdr_len" => "$rowC[37]",
					"hdr_id" => "$rowC[38]",
					"hdr_code" => "$rowC[39]",
					"hdr_type" => "$rowC[40]",
					"ip_ver" => "$rowC[41]",
					"ip_hlen" => "$rowC[42]",
					"ip_tos" => "$rowC[43]",
					"ip_len" => "$rowC[44]",
					"ip_id" => "$rowC[45]",
					"ip_off" => "$rowC[46]",
					"ip_flags" => "$rowC[47]",
					"ip_ttl" => "$rowC[48]",
					"ip_csum" => "$rowC[49]"
					));
					
					$cnt++;
					if ($cnt == 1000) {
						echo ".";
						unset($cnt);
					}
					$total++;
		    	}
				
    			$dataStoreObj->saveEventID();
		    	
				echo "\nFinished [$rowA[0] Events: $total]\n";
		    	
			} else {
				echo "Skipping [$rowA[0]]\n";
			}
    	}
    	
	}
	
}

class migrateDB {
    function migrateDB() {
        global $migratedbhost, $migratedbuser, $migratedbpass, $migratedb;

        $this->host = $migratedbhost;
        $this->db = $migratedb;
        $this->user = $migratedbuser;
        $this->pass = $migratedbpass;

		$this->link = mysql_connect($this->host, $this->user, $this->pass, 1);
		
        mysql_select_db($this->db);
    }

    function query($query) {
    	
        if ($result = @mysql_query($query, $this->link)) {
        	return $result;
        } else {
        	return false;
        }
    }

    function close() {
        @mysql_close($this->link);
    }
}

function recursiveModuleLoad() {
	global $root_path;

	if (!$this_dir = @dir("$root_path/modules/")) { echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting."; exit; }
	
	while ($dir = $this_dir->read()) {
        if ($dir != "." && $dir != "..") {
            if (substr($dir, -4, 4) == "_MOD") {
                $this_sub = dir("$root_path/modules/$dir");
                while ($file = $this_sub->read()) {
                    if ($file != "." && $file != "..") {
                        if (substr($file, 0,4) == "inc_") {
                            include_once "$root_path/modules/$dir/$file";
                        }
                    }
                }
            }
        }
	}
}

function getInput() {   

    $line = trim(fgets(STDIN));
    return $line;   
}                       
   

?>