<?php

error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);

main();

function main() {
	
	$out = "\nAanval Intrusion Detection and Correlation\nPre Installation System Check\n-------------------------------------------------------\n\n";
	
	$out .= functionExistTest();
	
	$out .= iniValueTest();
	
	$out .= DirectoryExistTest();

	$out .= DirectoryWriteTest();
	
	if (!$_SERVER['REQUEST_URI']) {
		// Console
		$out = str_replace("C1", "\033[31m", $out);
		$out = str_replace("C0", "\033[0m", $out);

		echo $out;
	} else {
		// Web
		$out = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", $out);
		$out = str_replace("C1", "<font color=darkred>", $out);
		$out = str_replace("C0", "</font>", $out);
		
		echo nl2br($out);
	}
}

function functionExistTest() {
	
	$out = "PHP Function Tests\n";
	
	$array = array(
	
		"ini_set",
		"file",
		"file_get_contents"
	
	);
	
	foreach ($array as $func) {
		
		$out .= "\t";
		
		if (function_exists($func)) {
			$out .= "PASS";
		} else {
			$out .= "C1FAILC0";
		}

		$out .= " - PHP Function: $func()\n";
		
	}
	
	return $out;
}

function DirectoryExistTest() {
	
	$out = "Directory Exist Tests\n";
	
	$array = array(
	
		"tmp",
		"logs",
		"poll",
		"conf",
		"syslog",
		"version",
		"dataStore",
		"indexStore"

	);
	
	$path = str_replace("/contrib/preInstall", "", getcwd());
	
	foreach ($array as $dir) {
		
		$out .= "\t";
		
		if (@is_dir("$path/$dir")) {
			$out .= "PASS";
		} else {
			$out .= "C1FAILC0";
		}

		$out .= " - Directory: '$path/$dir'\n";
		
	}
	
	return $out;
}

function DirectoryWriteTest() {
	
	$out = "Directory Write Tests\n";
	
	$array = array(
	
		"tmp",
		"logs",
		"poll",
		"conf",
		"syslog",
		"version",
		"dataStore",
		"indexStore"

	);
	
	$path = str_replace("/contrib/preInstall", "", getcwd());
	
	foreach ($array as $dir) {
		
		$out .= "\t";
		
		if (@is_writable("$path/$dir")) {
			$out .= "PASS";
		} else {
			$out .= "C1FAILC0";
		}

		$out .= " - Directory: '$path/$dir'\n";
		
	}
	
	return $out;
}

function iniValueTest() {
	
	$out = "PHP Configuration Tests\n";
	
	$array = array(
	
		"short_open_tag" => "1",
		"safe_mode" => "0"
	
	);
	
	foreach ($array as $ini => $val) {
		
		$out .= "\t";
		
		if ($val == 1) {
			if (ini_get($ini) == 1) {
				$out .= "PASS";
			} else {
				$out .= "FAIL";
			}
		} else {
			if (!ini_get($ini) || ini_get($ini) == 0) {
				$out .= "PASS";
			} else {
				$out .= "FAIL";
			}
		}
		
		$out .= " - PHP Configuration: $ini = $val\n";
	}
	
	return $out;
}

?>