<?

$version = "4.0A";
$globalError = 0;

################################################################################
# SENSOR MANAGEMENT TOOLS - AANVAL INTRUSION DETECTION CONSOLE
################################################################################

// Sets
error_reporting(E_ALL ^ E_NOTICE);
ini_set("memory_limit", -1);
ini_set("display_errors", 1);

// Set Script TIMEOUT Value
set_time_limit(2000);

// Includes
if (!include("conf.php")) {
	echo "ERROR - Could not access conf.php. Ensure it is in the local directory and / or 'open_basedir' is disabled in your php.ini\n\n";
}

// Launch
go();

function go() {
	global $version, $protocol, $consoleHost, $consoleHostPath, $id, $logging, $logfile, $globalError;

    echo "Aanval - Sensor Management Tools - v.$version\n---\n";
	smtLog("<----- SMT run started [v.$version] ----->");

    if (strtoupper($protocol) == "HTTPS") {
	    echo "* Using HTTPS > If you experience problems, please try http\n";
    }
    
    if ($logging == 0) {
    	echo "* Logging disabled\n";
    } else {
    	echo "* Logging Enabled: $logfile\n";
    }
    
    echo "* Connection URL: $protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id\n* Sensor Management ID: $id (must match sensor settings in console)\n---\n\n";
	smtLog("Connection URL: $protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id");

    if (errorChecking() == 0) $globalError = 1;
    
    if ($globalError == 0) {
		$res = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id");
	
		if ($res) {
			processMessage($res);
		} else {
			echo "ERROR - Connection to console failed. Check host and host path settings within your conf.php\n";
			smtLog("ERROR - Connection to console failed. Check host and host path settings within your conf.php");
			smtLog("ERROR - Additional help: Paste the \"Connection URL\" into browser and check for errors (in php logs too)");
			$globalError = 1;
		}
    }

    if ($globalError == 1) {
		echo "\n---\nFail => Error detected. See messages above.\n\n";
		smtLog("SMT run ended with errors");
    } else {
		echo "\n---\nSuccess => SMT's appear to be functioning properly.\n\n";
		smtLog("SMT run ended successfully");
    }
}

function processMessage($res) {
	global $protocol, $consoleHost, $consoleHostPath, $id, $confSnort, $rulesSnort, $sensorDataPath, $cmdSnortStatus, $cmdSnortStart, $cmdSnortStop, $cmdUptime, $logging, $globalError;
	
	$res = trim($res);
	
	if ($res == "") {
		$rmsg = "( ERROR: No message available. Check console php/webserver logs & check conf.php settings. )";
		smtLog("ERROR - Unable to retrieve sensor messages from console");
		smtLog("ERROR - Additional help: Make sure the SMT ID in conf.php matches sensor configuration in console");
		smtLog("ERROR - Additional help: Paste the \"Connection URL\" into browser and check for errors (in php logs too)");
		$globalError = 1;
	} else {
		$rmsg = "( 0 is okay )";
	}

	echo "SMT: Aanval Message Result\t[ $res ]\t$rmsg\n";
	
	smtLog("Message received from console: $res");
	
	executeMessage($res);
}

function executeMessage($res) {
	global $protocol, $consoleHost, $consoleHostPath, $id, $confSnort, $rulesSnort, $sensorDataPath, $cmdSnortStatus, $cmdSnortStart, $cmdSnortStop, $cmdUptime, $logging;
	
	if ($res == "SNORTRESTART") {
		
		$tmp = exec("$cmdSnortStop > /dev/null 2>&1 &", $data);
		smtLog("Snort Stop Command Executed: $cmdSnortStop");
		sleep(5);
        $tmp = exec("$cmdSnortStart > /dev/null 2>&1 &", $data);
		smtLog("Snort Start Command Executed: $cmdSnortStart");
		$code = 1;
		
	} else if ($res == "SNORTSTOP") {
        
		$tmp = exec("$cmdSnortStop > /dev/null 2>&1 &", $data);
		smtLog("Snort Stop Command Executed: $cmdSnortStop");
		$code = 2;
		
	} else if ($res == "SNORTSTART") {
        
		$tmp = exec("$cmdSnortStart > /dev/null 2>&1 &", $data);
		smtLog("Snort Start Command Executed: $cmdSnortStart");
		$code = 3;
		
    } else if ($res == "UPTIME") {

    	$tmp = exec($cmdUptime, $return);
		$data = urlBase64_encode($return[0]);
		$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&uptime=$data");
        $code = 4;
        
    } else if ($res == "SNORTCONFGET") {

    	$confData = file_get_contents($confSnort);
    	$postData = "id=$id&confsend=1&file=" . basename($confSnort) . "&data=" . urlBase64_encode($confData);
		sendToHost($consoleHost, "$consoleHostPath/poll/sensor_poll.php", $postData, 0);		
		$code = 5;
		
    } else if ($res == "SNORTCONFSEND") {
        
		$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&confget=1");
		if (!empty($tmp)) {
	        // Open File For Write
	        if ($fp = @fopen($confSnort, "w")) {
	        	fputs ($fp, urlBase64_decode($tmp));
	            fclose($fp);
	        }  
		}
		$code = 6;
		
    } else if ($res == "SNORTRULESGET") {

        if (!$rules = @dir("$rulesSnort")) {
            echo "ERROR - Could not locate rules (Check to ensure directories are correct in conf.php)";
            exit;
        }
        
        while ($fileTmp = $rules->read()) {
            if ($fileTmp != "." && $fileTmp != ".." && $fileTmp != basename($confSnort)) {
                $files[] = $fileTmp;
            }
        }
        		
		foreach($files as $file) {
	    	$ruleData = file_get_contents("$rulesSnort/$file");
	    	$postData = "id=$id&rulessend=1&file=$file&data=" . urlBase64_encode($ruleData);
			sendToHost($consoleHost, "$consoleHostPath/poll/sensor_poll.php", $postData, 0);			
			$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id");
			unset($tmp);
		}
    	$code = 7;
                		
    } else if ($res == "SNORTRULESSEND") {

		$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&rulesget=1");

        if ($tmp) {
    		$ruleList = explode("\n", $tmp);
		}

		foreach($ruleList as $rule) {
			$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&ruleget=1&rule=$rule");
			if (!empty($tmp)) {
		        // Open File For Write
		        if ($fp = @fopen("$rulesSnort/$rule", "w")) {
		        	fputs ($fp, urlBase64_decode($tmp));
		            fclose($fp);
		        }  
			}	
			$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id");
			unset($tmp);
		}
        $code = 8;
        
    } else if ($res == "SENSORUPDATE") {
    	
		$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&update=1");
        if ($tmp) {
	        if ($fp = @fopen("$sensorDataPath/smt.php.NEW", "w")) {
	        	fputs ($fp, urlBase64_decode($tmp));
	            fclose($fp);
	        } 
        }
		$code = 9;        
        
    } else if ($res == "SNORTSTATUS") {
    	
		$tmp = exec("$cmdSnortStatus", $data);
		if ($data) {
			echo "SMT: Snort Process Found\n";
			smtLog("Status Results: Snort Process Found");			
			$status = 1;
		} else {
			echo "SMT: Snort Process NOT Found\n";
			smtLog("Status Results: Snort Process NOT Found");
			smtLog("Status Command Executed: $cmdSnortStatus");
			$status = 0;
		}
		$tmp = file_get_contents("$protocol://$consoleHost$consoleHostPath/poll/sensor_poll.php?id=$id&snortstatus=1&data=$status");
        $code = 10;

	} else {
		$code = 0;
    }
	
	echo "SMT: Aanval Internal Code\t[ $code ]\n";
	
}

function errorChecking() {
	global $version, $protocol, $consoleHost, $consoleHostPath, $id, $logging;

    if (!$protocol) {
    	$msg = "ERROR - Protocol variable in configuration file is not set";
    	echo "$msg";
		smtLog("$msg");
    	return 0;
    }
    if (!$consoleHost) {
    	$msg = "ERROR - Console Host variable in configuration file is not set";
    	echo "$msg";
		smtLog("$msg");
    	return 0;
    }
    if (!$consoleHostPath) {
    	$msg = "ERROR - Console Host Path variable in configuration file is not set";
    	echo "$msg";
		smtLog("$msg");
    	return 0;
    }
    if (!$id) {
    	$msg = "ERROR - SMT ID variable in configuration file is not set";
    	echo "$msg";
		smtLog("$msg");
    	return 0;
    }	

    return 1;
}

function sendToHost($host, $path, $data, $useragent = 0) {
	global $protocol, $logging;
	
	$method = "POST";
	
	if ($protocol == "HTTPS" || $protocol == "https") {
		$port = 443;
	} else {
		$port = 80;
	}
	
    $fp = fsockopen($host, $port);

    fputs($fp, "$method $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp,"Content-type: application/x-www-form-urlencoded\r\n");
    fputs($fp, "Content-length: " . strlen($data) . "\r\n");
    if ($useragent) {
        fputs($fp, "User-Agent: MSIE\r\n");
    }
    fputs($fp, "Connection: close\r\n\r\n");
    if ($method == 'POST') {
        fputs($fp, $data);
    }

    while (!feof($fp)) {
        $buf .= fgets($fp,128);
    }
    fclose($fp);
    
    return $buf;
}

function sendToHost_Original($host, $path, $data, $useragent = 0) {
	global $protocol, $logging;
	
	$method = "POST";
	
	if ($protocol == "HTTPS" || $protocol == "https") {
		$port = 443;
	} else {
		$port = 80;
	}
	
    $fp = fsockopen($host, $port);

    fputs($fp, "$method $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp,"Content-type: application/x-www-form-urlencoded\r\n");
    fputs($fp, "Content-length: " . strlen($data) . "\r\n");
    if ($useragent) {
        fputs($fp, "User-Agent: MSIE\r\n");
    }
    fputs($fp, "Connection: close\r\n\r\n");
    if ($method == 'POST') {
        fputs($fp, $data);
    }

    while (!feof($fp)) {
        $buf .= fgets($fp,128);
    }
    fclose($fp);
    
    return $buf;
}

function smtLog($data) {
	global $logging, $logfile, $id;
	
	if ($logging == 0) return;

	$timestamp = date("d-m-Y H:i:s");
	
	$fh = fopen("$logfile", "a");
	fputs($fh, "$timestamp $id $data\n");
    fclose($fh);
}

function urlBase64_decode($string) {
  
	$string = str_replace( '-', '+', $string );
	$string = str_replace( '_', '/', $string );
	$string = str_replace( '.', '=', $string );
	
	return base64_decode($string);
}

function urlBase64_encode($string) {

	$string = base64_encode($string);
	$string = str_replace( '+', '-', $string );
	$string = str_replace( '/', '_', $string );
	$string = str_replace( '=', '.', $string );
	
	return $string;
}

?>