<?php

/** Copyright 2007 Remote Assessment
 *
 * Aanval 3
 *
 * This program is owned and licensed by Remote Assessment; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Remote Assessment and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Remote Assessment or Aanval agents.
 *
 * Remote Assessment and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);

ini_set("session.bug_compat_42", 1);
ini_set("session.bug_compat_warn", 0);
ini_set("memory_limit", -1);
ini_set("display_errors", 0);
ini_set("display_startup_errors", 0);

// Install / Upgrade
if (file_exists('installation/upgrade')) { header('Location: installation/setup.php'); exit; }
if (file_exists("./conf/conf.php")) { include "./conf/conf.php"; } else { echo "<b>ERROR: /conf/conf.php not found!<br>\nCheck to ensure it exists and / or permissions are set appropriately.<br>"; exit; }

$start_time = getmicrotime();

$dbOpenCount = 0;
$dbCloseCount = 0;

recursiveModuleLoad();

$idsDB = new idsDB;

$username = getVar("username");
$password = getVar("password");

$login = new mySession("aanval");
$login->initSession($username, $password);
$login->loadSession();

$ops = new myOps();
$ops->loadOps();

$op = getVar("op");
$redir = getVar("redir");
$eredir = getVar("eredir");

$scr = getVar("scr"); if (ops("site_statCache") == 0) $scr = 1; $sc = 0;
$qcr = getVar("qcr"); if (ops("site_queryCache") == 0) $qcr = 1; $qc = 0;

if (getVar("brandLoader") == 1) { $op = "pub_brandLoader"; }

languageCheck();

redirectOperations();

opDirector();

$idsDB->close();	

function recursiveModuleLoad() {
	global $root_path;

	if (!$this_dir = @dir("$root_path/modules/")) { echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting."; exit; }
	
	while ($dir = $this_dir->read()) {
        if ($dir != "." && $dir != "..") {
            if (substr($dir, -4, 4) == "_MOD") {
                $this_sub = dir("$root_path/modules/$dir");
                while ($file = $this_sub->read()) {
                    if ($file != "." && $file != "..") {
                        if (substr($file, 0,4) == "inc_") {
                            include_once "$root_path/modules/$dir/$file";
                        }
                    }
                }
            }
        }
    }
}

function getmicrotime() { list($usec, $sec) = explode(" ", microtime()); return ((float)$usec + (float)$sec); }

?>

