<?php

include ("jpgraph.php");
include ("jpgraph_bar.php");

$data = getVar("data");
$title = getVar("title");
$xaxis = getVar("xaxis");
$yaxis = getVar("yaxis");
$labels = getVar("labels");
$labelinterval = getVar("labelinterval");
$type = getVar("type");
$color = getVar("color");
$barWidth = "0.8";
$barWeight = "0.1";
if (!$labelinterval) $labelinterval = 1;

if (substr($data, -1) == ",") $data = substr($data, 0, -1);
if (substr($labels, -1) == ",") $labels = substr($labels, 0, -1);

$data = explode(",", trim($data));
$labels = explode(",", trim($labels));

if (count($data) > 150) {
	$barWidth = "0.3";
	$barWeight = "0.0";
}

// Create the graph
$graph = new Graph(600,200,"auto");
$graph->img->SetMargin(40,10,20,70);
$graph->SetScale("textlin");
$graph->SetMarginColor("white");
$graph->SetTickDensity(TICKD_DENSE, TICKD_DENSE);
$graph->SetBox("darkgray", "darkgray");
$graph->SetFrame(1, "darkgray");

// Create a bar plot
$bplot = new BarPlot($data);
$bplot->SetColor("darkgray");
$bplot->SetFillColor($color);
$bplot->SetFillGradient($color, 'white', 2);
$bplot->SetWidth($barWidth);
$bplot->SetWeight($barWeight);
$graph->Add($bplot);

$graph->title->Set("$title");
$graph->title->SetColor("black");
$graph->title->SetFont(FF_FONT1);
$graph->xaxis->title->Set("$xaxis");
$graph->xaxis->SetTickLabels($labels);
$graph->xaxis->SetTextTickInterval($labelinterval);
$graph->xaxis->SetLabelAngle(90);
$graph->xaxis->SetLabelMargin(8);
$graph->xaxis->SetColor("darkgray");
$graph->xaxis->HideTicks();
$graph->xaxis->title->SetFont(FF_FONT1);

$graph->yaxis->title->Set("$yaxis");
$graph->yaxis->HideTicks();
$graph->yaxis->title->SetFont(FF_FONT1);
$graph->yaxis->SetColor("darkgray");

// Display the graph
$graph->Stroke();

function getVar($in) {

	// Universal POST & GET Function

    if (isset($_POST[$in])) {
        $out = $_POST[$in];
    } else {
        $out = $_GET[$in];
    }
    
	if (get_magic_quotes_gpc()) {
        if (is_array($out)) {
            foreach ($out as $el) {
				$array[] = stripslashes($el);
            }
            $out = $array;
        } else {
	        $out = stripslashes($out);
        }    
	}
        
    return $out;
}

?>
