<?php

// SENSOR_POLL: Sensor Management Message Responder

include "../conf/conf.php";

// Sets
ini_set("memory_limit", -1);

// Set Script TIMEOUT Value
set_time_limit(2000);

// Tell the system we are in processor mode
$processor = 1;

// Load /modules/ directory recursively
recursiveModuleLoad();

// Load Database Connections
$idsDB = new idsDB;

// Simulate login to console
$login = new mySession("poll");

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

main();

// Close Database Connections
$idsDB->close();

function main() {
    global $root_path, $idsDB;

    $id = strip_tags(addslashes(getVar("id")));
    $snortstatus = getVar("snortstatus");
    $uptime = getVar("uptime");
    $confsend = getVar("confsend");
    $confget = getVar("confget");
    $rulessend = getVar("rulessend");
    $rulesget = getVar("rulesget");
    $ruleget = getVar("ruleget");
    $rule = getVar("rule");
    $data = getVar("data");
    $file = getVar("file");
    $update = getVar("update");

    // ID Variable Setting
    if (!$id) {
    	echo "Sensor management identification was not received. Exiting.";
		exit;
    }

    // UPTIME UPDATE
    if ($uptime) {

        exit;
    } else if ($snortstatus == 1) {
        if ($data == 1) {
            $alive = 1;
        } else {
            $alive = 0;
        }
        
        // Heartbeat
	    heartbeat($id);
        
        updateStatus($id, $alive);

    } else if ($confsend == 1) {
        @mkdir("$root_path/poll/sensorData/$id");
        
		// Open File For Write
        if ($fp = @fopen("$root_path" . "/poll/sensorData/$id/$file", "w")) {

        	// Decode and write
        	fputs ($fp, urlBase64_decode($data));

        	// Close file handle
            fclose($fp);

            // Update database with name of file   
			$idsQueryA = $idsDB->query("update idsSensor set confFile = '$file' where smtid = '$id'");
        }        
        
    } else if ($confget == 1) {
    	
        $idsQueryA = $idsDB->query("select confFile from idsSensor where smtid = '$id'");
		for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
			$confFile = $row[0];
		}
    	
        $data = @file("$root_path/poll/sensorData/$id/$confFile");
        if ($data) {
	        for($i=0;$i<count($data);$i++) {
	            $out .= $data[$i];
	        }
	        $out = urlBase64_encode($out);
        }
    } else if ($rulessend == 1) {
        @mkdir("$root_path/poll/sensorData/$id");

		// Open File For Write
        if ($fp = @fopen("$root_path" . "/poll/sensorData/$id/$file", "w")) {

        	fputs ($fp, urlBase64_decode($data));

        	// Close file handle
            fclose($fp);
        }          
        
		$ruleFile = file("$root_path/poll/sensorData/$id/$file");

		for($i=0;$i<count($ruleFile);$i++) {
			if (strstr($ruleFile[$i], "rev:") && strstr($ruleFile[$i], "sid:")) {
				preg_match("/sid[:][0-9]*/", $ruleFile[$i], $match);
			    $sidTemp = trim(rtrim($match[0]));
				$sidTemp = explode(":", $sidTemp);
				$sid = $sidTemp[1];

				if (strstr(substr($ruleFile[$i], 0, 5), "#")) {

				    // Rule Disabled
                    $out .= sigIndexUpdate($id, $sid, 0, $ruleFile[$i], $file);
	            } else {
             	    // Rule Enabled
                    $out .= sigIndexUpdate($id, $sid, 1, $ruleFile[$i], $file);
	        	}
		    }
		}
    		
    } else if ($rulesget == 1) {

        $idsQueryA = $idsDB->query("select confFile from idsSensor where smtid = '$id'");
		for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
			$confFile = $row[0];
		}    	
    	
        if (!$rules = @dir("$root_path/poll/sensorData/$id/")) {
            echo "ERROR - Could not locate rules";
            exit;
        }

        while ($file = $rules->read()) {
            if ($file != "." && $file != ".." && $file != "$confFile") {
                $out .= "$file\n";
            }
        }
    } else if ($ruleget == 1) {
        $data = file("$root_path/poll/sensorData/$id/$rule");
        for($i=0;$i<count($data);$i++) {
            if ($data[$i] != "" && $data[$i] != "\n") $out .= $data[$i];
        }
        $out = urlBase64_encode("$out");

    } else if ($update == 1) {

        $data = file_get_contents("$root_path/contrib/smt/smt.php");
        $out = urlBase64_encode("$data");
    	
    } else {

        // Heartbeat
	    heartbeat($id);

        $out = sensorMessage($id);
        
        // Update SMT's every X random number of connections
#        $ran = rand(1,100);
#        if ($ran == 50) $out = "SENSORUPDATE";
    }

	echo $out;
}

function recursiveModuleLoad() {
    global $root_path;

    # Read in all available modules recursively
    if (!$this_dir = @dir("$root_path/modules/")) {
        echo "conf.php ERROR:<p>\$root_path not correct or $root_path/modules/ not found! Check your conf.php settings<p>Exiting.";
        exit;
    }
    while ($dir = $this_dir->read()) {
        if ($dir != "." && $dir != "..") {
            if (substr($dir, -4, 4) == "_MOD") {
                $this_sub = dir("$root_path/modules/$dir");
                while ($file = $this_sub->read()) {
                    if ($file != "." && $file != "..") {
                        if (substr($file, 0,4) == "inc_") {
                            include "../modules/$dir/$file";
                        }
                    }
                }
            }
        }
    }
}

?>

